package ru.landgrafhomyak.db.serdha0.api.queries

import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.table.Table

public interface QueryConstructor<qUE : Any> {
	public fun createQuery(internalQueries: Scope, outQueries: Scope): qUE

	public interface Scope {
		public fun <qUE : Any, tUE : Any> deleteSingleRow(table: Table<tUE, *>, creator: DeleteQuery.SingleRow.Constructor<qUE, tUE>): DeleteQuery.SingleRow<qUE>
		public fun <qUE : Any, tUE : Any, sUE : Any> deleteFromSubquery(table: Table<tUE, *>, selector: _Selectable<sUE>, creator: DeleteQuery.FromSubquery.Constructor<qUE, tUE, sUE>): DeleteQuery.FromSubquery<qUE>
		public fun <qUE : Any, tUE : Any> deleteMultipleRows(table: Table<tUE, *>, creator: DeleteQuery.MultipleRows.Constructor<qUE, tUE>): DeleteQuery.MultipleRows<qUE>

		public fun <qUE : Any, tUE : Any> insertSingleRow(table: Table<tUE, *>, creator: InsertQuery.SingleRow.Constructor<qUE, tUE>): InsertQuery.SingleRow<qUE>
		public fun <qUE : Any, tUE : Any, sUE : Any> insertFromSubquery(table: Table<tUE, *>, selector: _Selectable<sUE>, creator: InsertQuery.FromSubquery.Constructor<qUE, tUE, sUE>): InsertQuery.FromSubquery<qUE>
		public fun <qUE : Any, tUE : Any> insertMultipleRows(table: Table<tUE, *>, creator: InsertQuery.MultipleRows.Constructor<qUE, tUE>): InsertQuery.MultipleRows<qUE>

		public fun <qUE : Any, tUE : Any> select(table: _Selectable<tUE>, creator: SelectQuery.Simple.Constructor<qUE, tUE>): SelectQuery.Simple<qUE>
		public fun <qUE : Any, lUE : Any, rUE : Any> selectWithJoin(left: _Selectable<lUE>, right: _Selectable<rUE>, creator: SelectQuery.WithJoin.Constructor<qUE, lUE, rUE>): SelectQuery.WithJoin<qUE>

		public fun <qUE : Any, tUE : Any> updateSingleRow(table: Table<tUE, *>, creator: UpdateQuery.SingleRow.Constructor<qUE, tUE>): UpdateQuery.SingleRow<qUE>
		public fun <qUE : Any, tUE : Any, sUE : Any> updateFromSubquery(table: Table<tUE, *>, selector: _Selectable<sUE>, creator: UpdateQuery.FromSubquery.Constructor<qUE, tUE, sUE>): UpdateQuery.FromSubquery<qUE>
		public fun <qUE : Any, tUE : Any> updateMultipleRows(table: Table<tUE, *>, creator: UpdateQuery.MultipleRows.Constructor<qUE, tUE>): UpdateQuery.MultipleRows<qUE>
	}
}